=== added file 'src/com/goldencode/p2j/ui/CalendarWidget.java'
--- src/com/goldencode/p2j/ui/CalendarWidget.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/CalendarWidget.java	2020-02-25 14:33:57 +0000
@@ -0,0 +1,768 @@
+/*
+** Module   : CalendarWidget.java
+** Abstract : The calendar widget on the server side.
+**
+** Copyright (c) 2020, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- --------------------------------Description-----------------------------------
+** 001 SBI 20200114 Created initial version.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+package com.goldencode.p2j.ui;
+
+import com.goldencode.p2j.util.*;
+
+
+/**
+ * Implements the calendar widget on the server side.
+ */
+public class CalendarWidget
+extends ControlEntityExt<CalendarConfig>
+implements Calendar
+{
+   /**
+    * Creates the instance of the calendar widget.
+    */
+   public CalendarWidget()
+   {
+      this(false);
+   }
+   
+   /**
+    * Creates the instance of the calendar widget.
+    * 
+    * @param   dynamic
+    *          The flag indicating if this is a static or dynamic resource.
+    */
+   public CalendarWidget(boolean dynamic)
+   {
+      this(dynamic, new CalendarConfig());
+   }
+   
+   /**
+    * Creates the instance of the calendar widget.
+    * 
+    * @param    dynamic
+    *           The flag indicating if this is a static or dynamic resource.
+    * @param    config
+    *           The widget configuration settings
+    */
+   public CalendarWidget(boolean dynamic, CalendarConfig config)
+   {
+      super(dynamic, config);
+   }
+   
+   /**
+    * Return a value that determines whether a form or control can respond to user-generated events.
+    * 
+    * @return   The current state whether a form or control can respond to user-generated events
+    */
+   @Override
+   public logical isEnabled()
+   {
+      return this.isSensitive();
+   }
+
+   /**
+    * Sets a value that determines whether a form or control can respond to user-generated events.
+    * 
+    * @param    enabled
+    *           The new state whether a form or control can respond to user-generated events
+    */
+   @Override
+   public void setEnabled(logical enabled)
+   {
+      this.setSensitive(enabled);
+   }
+
+   /**
+    * Sets a value that determines whether a form or control can respond to user-generated events.
+    * 
+    * @param    enabled
+    *           The new state whether a form or control can respond to user-generated events
+    */
+   @Override
+   public void setEnabled(boolean enabled)
+   {
+      this.setSensitive(enabled);
+   }
+
+   /**
+    * Returns the current date time value as a character value.
+    * 
+    * @return   The current date time value as a character value
+    */
+   @Override
+   public character getDateTimeValue()
+   {
+      return new character(config.dateTimeValue);
+   }
+
+   /**
+    * Sets the current date and time value.
+    * 
+    * @param    value
+    *           The new current date and time value
+    */
+   @Override
+   public void setDateTimeValue(datetime value)
+   {
+      config.dateTimeValue = value.getIsoDate();
+      
+      pushWidgetAttr(new String[] {"dateTimeValue", "formatStyle"},
+                     new Object[] {config.dateTimeValue, config.formatStyle});
+   }
+
+   /**
+    * Sets the current date value.
+    * 
+    * @param    value
+    *           The new current date value
+    */
+   @Override
+   public void setDateTimeValue(date value)
+   {
+      setDateTimeValue(new datetime(value));
+   }
+
+   /**
+    * Sets the current date and time value as a character value.
+    * 
+    * @param    value
+    *           The new current date and time value as a character value
+    */
+   @Override
+   public void setDateTimeValue(character value)
+   {
+      setDateTimeValue(new datetime(value));
+   }
+   
+   /**
+    * Sets the current date and time value representing by a string.
+    * 
+    * @param    value
+    *           The new current date and time value representing by a string
+    */
+   @Override
+   public void setDateTimeValue(String value)
+   {
+      setDateTimeValue(new datetime(value));
+   }
+   
+   /**
+    * Determines whether dates and times are displayed using standard or custom formatting.
+    * 
+    * @return   The date and time display format style constant.
+    */
+   @Override
+   public integer getFormatStyle()
+   {
+      return new integer(config.formatStyle);
+   }
+   
+   /**
+    * Determines whether dates and times are displayed using standard or custom formatting.
+    * 
+    * @param    formatStyle
+    *           The date and time display format style constant.
+    */
+   @Override
+   public void setFormatStyle(integer formatStyle)
+   {
+      if (formatStyle == null || formatStyle.isUnknown())
+      {
+         return;
+      }
+      
+      config.formatStyle = formatStyle.intValue();
+
+      pushWidgetAttr(new String[] {"formatStyle"}, new Object[] {config.formatStyle});
+   }
+   
+   /**
+    * Returns the background color used to display the month portion of the dropdown calendar.
+    * 
+    * @return   The background color for the dropdown calendar
+    */
+   @Override
+   public integer getCalendarBackColor()
+   {
+      return new integer(config.bodyBackgroundColor);
+   }
+   
+   /**
+    * Sets the background color used to display the month portion of the dropdown calendar.
+    * 
+    * @param    calendarBackColor
+    *           The background color for the dropdown calendar
+    */
+   @Override
+   public void setCalendarBackColor(integer calendarBackColor)
+   {
+      if (calendarBackColor == null || calendarBackColor.isUnknown())
+      {
+         return;
+      }
+      
+      config.bodyBackgroundColor = calendarBackColor.intValue();
+      
+      pushWidgetAttr(new String[] {"bodyBackgroundColor"},
+                     new Object[] {config.bodyBackgroundColor});
+   }
+   
+   /**
+    * Returns the foreground color used to display text in the month portion of the dropdown calendar.
+    * 
+    * @return   The foreground color for the dropdown calendar
+    */
+   @Override
+   public integer getCalendarForeColor()
+   {
+      return new integer(config.bodyForegroundColor);
+   }
+   
+   /**
+    * Sets the foreground color used to display text in the month portion of the dropdown calendar.
+    * 
+    * @param    calendarForeColor
+    *           The foreground color for the dropdown calendar
+    */
+   @Override
+   public void setCalendarForeColor(integer calendarForeColor)
+   {
+      if (calendarForeColor == null || calendarForeColor.isUnknown())
+      {
+         return;
+      }
+      
+      config.bodyForegroundColor = calendarForeColor.intValue();
+      
+      pushWidgetAttr(new String[] {"bodyForegroundColor"},
+                     new Object[] {config.bodyForegroundColor});
+   }
+   
+   /**
+    * Returns the background color used to display the title portion of the dropdown calendar.
+    * 
+    * @return   The background color for the title portion of the dropdown calendar.
+    */
+   @Override
+   public integer getCalendarTitleBackColor()
+   {
+      return new integer(config.titleBackgroundColor);
+   }
+   
+   /**
+    * Sets the background color used to display the title portion of the dropdown calendar.
+    * 
+    * @param    titleBackColor
+    *           The background color for the title portion of the dropdown calendar.
+    */
+   @Override
+   public void setCalendarTitleBackColor(integer titleBackColor)
+   {
+      if (titleBackColor == null || titleBackColor.isUnknown())
+      {
+         return;
+      }
+      
+      config.titleBackgroundColor = titleBackColor.intValue();
+      
+      pushWidgetAttr(new String[] {"titleBackgroundColor"},
+                     new Object[] {config.titleBackgroundColor});
+   }
+   
+   /**
+    * Returns the foreground color used to display the title portion of the dropdown calendar.
+    * 
+    * @return   The foreground color for the title portion of the dropdown calendar.
+    */
+   @Override
+   public integer getCalendarTitleForeColor()
+   {
+      return new integer(config.titleForegroundColor);
+   }
+   
+   /**
+    * Sets the foreground color used to display the title portion of the dropdown calendar.
+    * 
+    * @param    titleForeColor
+    *           The foreground color for the title portion of the dropdown calendar.
+    */
+   @Override
+   public void setCalendarTitleForeColor(integer titleForeColor)
+   {
+      if (titleForeColor == null || titleForeColor.isUnknown())
+      {
+         return;
+      }
+      
+      config.titleForegroundColor = titleForeColor.intValue();
+      
+      pushWidgetAttr(new String[] {"titleForegroundColor"},
+                     new Object[] {config.titleForegroundColor});
+   }
+   
+   /**
+    * Returns the foreground color used to display the days at the beginning and end of
+    * the dropdown calendar that are from previous and following months.
+    * 
+    * @return   The foreground color for the previous and following months of
+    *           the dropdown calendar.
+    */
+   @Override
+   public integer getCalendarTrailingForeColor()
+   {
+      return new integer(config.trailingForegroundColor);
+   }
+   
+   /**
+    * Sets the foreground color used to display the days at the beginning and end of the dropdown
+    * calendar that are from previous and following months.
+    * 
+    * @param    trailingForeColor
+    *           The foreground color for the previous and following months of
+    *           the dropdown calendar.
+    */
+   @Override
+   public void setCalendarTrailingForeColor(integer trailingForeColor)
+   {
+      if (trailingForeColor == null || trailingForeColor.isUnknown())
+      {
+         return;
+      }
+      
+      config.trailingForegroundColor = trailingForeColor.intValue();
+      
+      pushWidgetAttr(new String[] {"trailingForegroundColor"},
+                     new Object[] {config.trailingForegroundColor});
+   }
+   
+   /**
+    * Returns whether the control displays a checkbox to the left of the date. When unchecked,
+    * no date is selected.
+    * 
+    * @return   True if it displays a checkbox to the left of the date, otherwise false.
+    */
+   @Override
+   public logical isCheckBox()
+   {
+      return new logical(config.checkBox);
+   }
+   
+   /**
+    * Sets whether the control displays a checkbox to the left of the date. When unchecked,
+    * no date is selected.
+    * 
+    * @param    enabledCheckBox
+    *           The logical value indicating a checkbox is displayed or not.
+    */
+   @Override
+   public void setCheckBox(logical enabledCheckBox)
+   {
+      if (enabledCheckBox == null || enabledCheckBox.isUnknown())
+      {
+         return;
+      }
+      
+      config.checkBox = enabledCheckBox.booleanValue();
+      
+      pushWidgetAttr(new String[] {"checkBox"}, new Object[] {config.checkBox});
+   }
+   
+   /**
+    * Returns the custom format string used to format the date and/or time displayed
+    * in the control.
+    * 
+    * @return   The custom format string
+    */
+   @Override
+   public character getCustomFormat()
+   {
+      return new character(config.customFormat);
+   }
+   
+   /**
+    * Sets the custom format string used to format the date and/or time displayed in the control.
+    * 
+    * @param    customFormat
+    *           The custom format string
+    */
+   @Override
+   public void setCustomFormat(character customFormat)
+   {
+      setCustomFormat(customFormat.getValue());
+   }
+   
+   /**
+    * Sets the custom format string used to format the date and/or time displayed in the control.
+    * 
+    * @param    customFormat
+    *           The custom format string
+    */
+   @Override
+   public void setCustomFormat(String customFormat)
+   {
+      config.customFormat = customFormat;
+      
+      pushWidgetAttr(new String[] {"customFormat", "formatStyle"},
+                     new Object[] {config.customFormat, config.formatStyle});
+   }
+   
+   /**
+    * Returns the day number [1-31] for the current date.
+    * 
+    * @return   The day number for the current date
+    */
+   @Override
+   public integer getDay()
+   {
+      return new integer(config.day);
+   }
+   
+   /**
+    * Sets the day number [1-31] for the current date.
+    * 
+    * @param    day
+    *           The day number for the current date
+    */
+   @Override
+   public void setDay(integer day)
+   {
+      if (day == null || day.isUnknown())
+      {
+         return;
+      }
+      
+      config.day = day.intValue();
+      
+      pushWidgetAttr(new String[] {"day"}, new Object[] {config.day});
+   }
+   
+   /**
+    * Returns the day of the week [0-6] for the current date.
+    * 
+    * @return   The day of the week for the current date
+    */
+   @Override
+   public integer getDayOfWeek()
+   {
+      return new integer(config.dayOfWeek);
+   }
+   
+   /**
+    * Sets the day of the week [0-6] for the current date.
+    * 
+    * @param    dayOfWeek
+    *           The day of the week for the current date
+    */
+   @Override
+   public void setDayOfWeek(integer dayOfWeek)
+   {
+      if (dayOfWeek == null || dayOfWeek.isUnknown())
+      {
+         return;
+      }
+      
+      config.dayOfWeek = dayOfWeek.intValue();
+      
+      pushWidgetAttr(new String[] {"dayOfWeek"}, new Object[] {config.dayOfWeek});
+   }
+   
+   /**
+    * Returns the hour number [0-23] for the current time.
+    * 
+    * @return   The hour number for the current time
+    */
+   @Override
+   public integer getHour()
+   {
+      return new integer(config.hour);
+   }
+   
+   /**
+    * Sets the hour number [0-23] for the current time.
+    * 
+    * @param    hour
+    *           The hour number for the current time
+    */
+   @Override
+   public void setHour(integer hour)
+   {
+      if (hour == null || hour.isUnknown())
+      {
+         return;
+      }
+      
+      config.hour = hour.intValue();
+      
+      pushWidgetAttr(new String[] {"hour"}, new Object[] {config.hour});
+   }
+   
+   
+   /**
+    * Returns the latest date that can be displayed or accepted by the control.
+    * 
+    * @return   The latest date that can be displayed or accepted by this control
+    */ 
+   @Override
+   public date getMaxDate()
+   {
+      return config.latestDate;
+   }
+   
+   /**
+    * Sets the latest date that can be displayed or accepted by the control.
+    * 
+    * @param    dateMaxDate
+    *           The new latest date
+    */
+   @Override
+   public void setMaxDate(date dateMaxDate)
+   {
+      if (dateMaxDate == null || dateMaxDate.isUnknown())
+      {
+         return;
+      }
+      
+      config.latestDate = dateMaxDate;
+      
+      pushWidgetAttr(new String[] {"latestDate"}, new Object[] {config.latestDate});
+   }
+   
+   /**
+    * Returns the earliest date that can be displayed or accepted by the control.
+    * 
+    * @return   The earliest date
+    */
+   @Override
+   public date getMinDate()
+   {
+      return config.earliestDate;
+   }
+   
+   /**
+    * Sets the earliest date that can be displayed or accepted by the control.
+    * 
+    * @param    dateMinDate
+    *           The new earliest date
+    */
+   @Override
+   public void setMinDate(date dateMinDate)
+   {
+      if (dateMinDate == null || dateMinDate.isUnknown())
+      {
+         return;
+      }
+      
+      config.earliestDate = dateMinDate;
+      
+      pushWidgetAttr(new String[] {"earliestDate"}, new Object[] {config.earliestDate});
+   }
+   
+   /**
+    * Returns the minute number [0-59] for the current time.
+    * 
+    * @return   The minute number for the current time
+    */
+   @Override
+   public integer getMinute()
+   {
+      return new integer(config.minute);
+   }
+   
+   /**
+    * Sets the minute number [0-59] for the current time.
+    * 
+    * @param    minute
+    *           The minute number for the current time
+    */
+   @Override
+   public void setMinute(integer minute)
+   {
+      if (minute == null || minute.isUnknown())
+      {
+         return;
+      }
+
+      config.minute = minute.intValue();
+      
+      pushWidgetAttr(new String[] {"minute"}, new Object[] {config.minute});
+   }
+   
+   /**
+    * Returns the month number [1-12] for the current date.
+    * 
+    * @return   The month number for the current date
+    */
+   @Override
+   public integer getMonth()
+   {
+      return new integer(config.month);
+   }
+   
+   /**
+    * Sets the month number [1-12] for the current date.
+    * 
+    * @param    month
+    *           The month number for the current date
+    */
+   @Override
+   public void setMonth(integer month)
+   {
+      if (month == null || month.isUnknown())
+      {
+         return;
+      }
+      
+      config.month = month.intValue();
+      
+      pushWidgetAttr(new String[] {"month"}, new Object[] {config.month});
+   }
+   
+   /**
+    * Returns the second number [0-59] for the current time.
+    * 
+    * @return   The second number for the current time
+    */
+   @Override
+   public integer getSecond()
+   {
+      return new integer(config.second);
+   }
+   
+   /**
+    * Sets the second number [0-59] for the current time.
+    * 
+    * @param    second
+    *           The second number for the current time
+    */
+   @Override
+   public void setSecond(integer second)
+   {
+      if (second == null || second.isUnknown())
+      {
+         return;
+      }
+      
+      config.second = second.intValue();
+      
+      pushWidgetAttr(new String[] {"second"}, new Object[] {config.second});
+   }
+   
+   /**
+    * Returns a value that determines whether an updown (spin) button is used to modify dates
+    * instead of a dropdown calendar.
+    * 
+    * @return   True value if the updown spin button is used to modify dates instead of a dropdown
+    *           calendar, otherwise false value.
+    */
+   @Override
+   public logical isUpDown()
+   {
+      return new logical(config.upDown);
+   }
+   
+   /**
+    * Sets a value that determines whether an updown (spin) button is used to modify dates instead
+    * of a dropdown calendar.
+    * 
+    * @param    upDown
+    *           The logical value indicating if the updown (spin) button is used to modify dates
+    */
+   @Override
+   public void setUpDown(logical upDown)
+   {
+      if (upDown == null || upDown.isUnknown())
+      {
+         return;
+      }
+      
+      config.upDown = upDown.booleanValue();
+      
+      pushWidgetAttr(new String[] {"upDown"}, new Object[] {config.upDown});
+   }
+   
+   /**
+    * Returns the year for the current date.
+    * 
+    * @return   The year for the current date
+    */
+   @Override
+   public integer getYear()
+   {
+      return new integer(config.year);
+   }
+   
+   /**
+    * Sets the year for the current date.
+    * 
+    * @param    year
+    *           The year for the current date
+    */
+   @Override
+   public void setYear(integer year)
+   {
+      if (year == null || year.isUnknown())
+      {
+         return;
+      }
+      
+      config.year = year.intValue();
+      
+      pushWidgetAttr(new String[] {"year"}, new Object[] {config.year});
+   }
+}

=== modified file 'src/com/goldencode/p2j/ui/ConfigManager.java'
--- src/com/goldencode/p2j/ui/ConfigManager.java	2020-01-30 19:23:31 +0000
+++ src/com/goldencode/p2j/ui/ConfigManager.java	2020-02-25 17:07:06 +0000
@@ -27,6 +27,7 @@
 ** 017 HC  20200128 Removed client-server widget config definitions synchronization. Client and
 **                  server config managers can now be dynamically extended with new widget
 **                  configurations.
+** 018 SBI 20200225 Added Calendar widget support.
 */ 
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -164,6 +165,7 @@
       configs.add(ControlFrameConfig.class);
       configs.add(ControlSetConfig.class);
       configs.add(ControlTextConfig.class);
+      configs.add(CalendarConfig.class);
       configs.add(EditorConfig.class);
       configs.add(FieldGroupConfig.class);
       configs.add(FillInConfig.class);

